Attribute VB_Name = "Module1"
' Allgemeine Proceduren, Funktionen und Variablendeklarationen
' Dinge die jeder mal braucht oder die berall gebraucht werden
Public Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hwnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)
Public dicevalue(4) As Integer      ' Werte der 5 Wrfel

Public spieleranzahl As Integer     ' Anzahl der Spierle
Public aktspieler As Integer        ' Aktueller Spieler
Public wurf As Integer              ' Nummer des Wurfes zur Anzeige auf dem Knopf
Public multikniffel As Boolean      ' Sonderregel aktiviert?
Public spielername(2) As String     ' die Spielernamen
Public cheat As Boolean             ' Fudeln oder nicht (nur je wurf)

Public Const w0 = "Wurf "           ' Textkonstanten
Public Const w1 = "ENDE"
Public Const vcolnorm = &HE0E0E0    ' Farben der Knpfe - normal
Public Const vcolposs = &HC0FFC0    ' ein grn - mglicher Wurf
Public Const vcolnull = &HC0E0FF    ' ein rot - mglich aber nicht ratsam
Public Const pnamedef = "Anonym "   ' zum Anlegen der higscordatei
Public Const fname = "Kniffel.dat"  ' Name der Highscoredatei
Public Type playerrecdef            ' Satzaufbau der Highscoredatei
    Pname As String * 20
    pscore As Integer
    pdate As Date
End Type

Public cptable(2, 19) As playerrecdef ' Highscoretabellen Einzel und Combo
                                      ' und ne leere fr was auch immer
Public drec As playerrecdef

Public cmd, k As Variant            ' Varianten fr Knpfe z.B.
'Mach mal ne pause bei 0 auf Taste waren (nicht implementiert)
Public Sub delay(pause As Integer)
If pause = 0 Then
   'Do Until keypressed
Else
   Start = Timer   ' Anfangszeit setzen.
   Do While Timer < Start + pause
      DoEvents   ' Steuerung an andere Prozesse abgeben.
   Loop
End If

End Sub
' gehrt eher zu Form1 , lscht und setzt die Label, wir aber auch in Form2
' benutzt ist also doch eher allgemein, oder?
Public Sub setplayer(Index As Integer)
    If Index = 0 Then
        Form1.Label2(0).Caption = ""
        Form1.Label2(1).Caption = ""
        Form1.Label2(2).Caption = ""
    Else
        Form1.Label2(0).Caption = spielername(0)
        Form1.Label2(1).Caption = spielername(1)
        Form1.Label2(2).Caption = spielername(2)
    End If
End Sub

'Tabelle initial anlegen - War mir in Form1 im Weg
Public Sub inittable()
    Dim i, j As Integer
    For j = 0 To 1
        For i = 1 To 19
            cptable(j, i).Pname = pnamedef
            cptable(j, i).pdate = Date
            cptable(j, i).pscore = 0
        Next i
    Next j
    spielername(0) = "Spieler 0"
    spielername(1) = "Spieler 1"
    spielername(2) = "Spieler 2"
End Sub

'Highscoretabelle einlesen
Public Sub getfile()

    Dim i, j As Integer
    For j = 0 To 1
        For i = 1 To 19
            Get #1, j * 19 + i, drec
            cptable(j, i).Pname = drec.Pname
            cptable(j, i).pscore = drec.pscore
            cptable(j, i).pdate = drec.pdate
        Next i
    Next j
    Get #1, 39, drec
    spielername(0) = drec.Pname
    Get #1, 40, drec
    spielername(1) = drec.Pname
    Get #1, 41, drec
    spielername(2) = drec.Pname

End Sub

'Highscoretabelle schreiben
Public Sub putfile()

    Dim i, j As Integer
    For j = 0 To 1
        For i = 1 To 19
            drec.Pname = cptable(j, i).Pname
            drec.pscore = cptable(j, i).pscore
            drec.pdate = cptable(j, i).pdate
            Put #1, j * 19 + i, drec
        Next i
    Next j
    drec.Pname = spielername(0)
    Put #1, 39, drec
    drec.Pname = spielername(1)
    Put #1, 40, drec
    drec.Pname = spielername(2)
    Put #1, 41, drec
End Sub
' Was wurde gewrfelt und als was kann man das eintragen
Public Sub checkpossibilities()
    Dim i, j, ta, pt, sq As Integer
    Dim w(4) As Integer
    
    'Arbeitstabelle fllen
    For i = 0 To 4
        w(i) = dicevalue(i)
    Next i

    '=== TABELLE SORTIEREN
    Do
    ta = 0
        For i = 0 To 3
            If w(i + 1) < w(i) Then
                pt = w(i)
                w(i) = w(i + 1)
                w(i + 1) = pt
                ta = 1
            End If
        Next i
    Loop Until ta = 0

    ' Werte 1 bis 6 prfen und ggf auf den Knopf schreiben
    For i = 0 To 5
        j = checknum(i + 1)
        If j <> 0 Then
            setvalue i, j
        End If
    Next i
    
    '---------------------------
    ' Punkte des Wurfes ermitteln (alle Augen addieren)
    pt = w(0) + w(1) + w(2) + w(3) + w(4)
    
    ' dreier Pash? Wenn Ja eintragen
    If (w(0) = w(1) And w(1) = w(2)) Or (w(2) = w(3) And w(2) = w(4)) Or (w(1) = w(2) And w(2) = w(3)) Then
        setvalue 9, pt
    End If

    '=== 4 - PASCH - Wie Dreier Pasch nur einer mehr
    If (w(0) = w(1) And w(1) = w(2) And w(2) = w(3)) Or (w(1) = w(2) And w(2) = w(3) And w(3) = w(4)) Then
        setvalue 10, pt
    End If
            
    '=== FULL HOUSE - entweder sind die ersten zwei und die letzen drei gleich
    ' oder es sind die ersten drei und die letzen zwei gleich
    If ((w(0) = w(1) And w(1) = w(2)) And w(3) = w(4)) Or (w(0) = w(1) And w(1) And (w(2) = w(3) And w(3) = w(4))) Then
        setvalue 11, 25
    End If
    
    '=== KLEINE STRASSE
    ' komplizierter - also bei drei Vergleichen muss der Wrfel um 1 grer sein
    ' als der nachfolgende. Die Summe aller am erfolgreichen Vergleich beteiligten
    ' ist entweder 15, 21 oder 27. Weil die mglichen Kombimatione ja nur x1x2x3x4x
    ' x2x3x4x5x, und x3x4x5x6x sein knnen, aber an allen x Stellen ein Weitere
    ' Wrfel mit dem gleichen Wert wie sein Vorgnger setehn knnte
    ta = 0
    sq = 0
    For i = 0 To 3
        If w(i) + 1 = w(i + 1) Then
            ta = ta + 1
            sq = sq + w(i) + w(i + 1)
        End If
        ' wenn es der richtige wErt war - eintragen
        If ta > 2 And (sq = 15 Or sq = 21 Or sq = 27) Then
            setvalue 12, 30
        End If
    Next i
    
    
    '=== GROSSE STRASSE
    ' einfacher weil alle Wrfel beteiligt sind und es nur 12345 oder 23456 gibt
    If w(0) = 1 And w(1) = 2 And w(2) = 3 And w(3) = 4 And w(4) = 5 Then
        setvalue 13, 40
    Else
        If w(0) = 2 And w(1) = 3 And w(2) = 4 And w(3) = 5 And w(4) = 6 Then
           setvalue 13, 40
        End If
    End If
    
    '=== CHANCE einfac h die Punkte rein
    setvalue 14, pt
    
    '=== Y A T Z E E - Alles gleiche Wrfel
    ta = 0
    For i = 0 To 4
        If w(1) <> w(i) Then ta = 1
    Next i
    If ta = 0 Then
        setvalue 15, 50
    End If
   
End Sub
' WErte von 1 bis 6 prfen - Unterprogramm
Private Function checknum(tocheck As Integer) As Integer
Dim i, rc As Integer
checknum = 0
For i = 0 To 4
    If dicevalue(i) = tocheck Then
        checknum = checknum + tocheck
    End If
Next i
End Function

' Eintragen der gewrfelten Werte als auswhlbar
Private Sub setvalue(ByVal i, ByVal j As Integer)
      Dim Antwort As Integer
      'erstmal kein Multikniffel
      multikniffel = False
      
      ' na klar - je Spalte
      For Each k In cmd
        With k
            If .Item(i).Enabled = True Then
                .Item(i).Caption = Str(j)
                .Item(i).BackColor = vcolposs
            Else
                'Sonderregelung fr Mehrfachkniffel
                If i = 15 And Form1.mnumkniffel.Checked = True And multikniffel = False Then
                    If Val(cmd(aktspieler).Item(15).Caption) >= 50 Then
                        Antwort = MsgBox("Ihr Kniffelbonus wird gem Voreinstellung" & Chr(13) & Chr(10) & "um 50 erhht. Whlen sie nun ein beliebiges Feld zm Eintragen.", vbOKOnly, "Mehrfach Kniffel")
                        multikniffel = True
                    End If
                End If
                
            End If
        End With
    Next
End Sub
